#define F_CPU 16000000U
#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>
#define LCD_INST (*(volatile unsigned char *)0x8000)
#define LCD_DATA (*(volatile unsigned char *)0x8002)

unsigned char ADC_L = 0x00; 
unsigned char ADC_H = 0x00; 
unsigned int ADC_RESULT = 0x00; 
unsigned char c1,c2,c3,c4; 

void LCD_data(char ch)
{
	LCD_DATA = ch; // Write data
	_delay_us(50);
}
void LCD_comm(char ch)
{
	LCD_INST=ch; // Write instruction
	_delay_ms(5);
}
void LCD_CHAR(char c) // Display one character
{
	LCD_data(c);
}
void LCD_STR(char *str) // Display a string
{
	while(*str)
	LCD_CHAR(*str++);
}
void LCD_pos(char col, char row) // Start position
{
	LCD_comm(0x80|(col+row*0x40));
}
void LCD_clear(void)
{
	LCD_comm(1);
}
void LCD_init(void)
{
	LCD_comm(0x38); // Function Set: Data line 8bit, 5X8 dot, 2 Line
	LCD_comm(0x0C); // Display ON/OFF
	LCD_comm(0x06); // Entry Mode Set:
	LCD_clear();
}
int main(void)
{
	MCUCR = 0x80; // Address and data bus
	
	DDRD = 0xf0;
	DDRB = 0x10;
	
	ADCH = 0x00; 
	ADCL = 0x00; 
	ADMUX = 0x00; 
	
	LCD_init();
	TCCR0 = 0x7c; /* Timer0 Fast PWM clk/64 */
	while(1)
	{
		ADCSR = 0xc7; 
		while((ADCSR & 0x10)==0);
		ADC_L = ADCL; 
		ADC_H = ADCH; 
		PORTD = ~(ADC_L << 4);
		OCR0=(ADC_L>>2) | (ADC_H<<6);
		
		ADC_RESULT = 0x00;
		ADC_RESULT = ADC_RESULT | ADC_H;
		ADC_RESULT = 0x0300 & (ADC_RESULT << 8);
		ADC_RESULT = ADC_RESULT | ADC_L;

		c4 = ADC_RESULT / 1000;
		c3 = (ADC_RESULT % 1000) / 100;
		c1 = ADC_RESULT % 100;
		c2 = c1/10;
		c1 = c1 % 10;
		LCD_pos(0,0);
		LCD_STR((char*)"ADC:");
		LCD_CHAR(c4+0x30);
		LCD_CHAR(c3+0x30);
		LCD_CHAR(c2+0x30);
		LCD_CHAR(c1+0x30);
		_delay_ms(5);
	}
}



